<?php
require_once 'HNotifier.php';

class HLog {
    function init() {
        set_error_handler(array('HLog', '_errorCallback'));
        openlog(false, LOG_ODELAY, LOG_LOCAL0);
    }

    function alert($opt, $err = null) {
        syslog(LOG_ALERT, 'ALERT: ' . $opt);
        HLog::_doNotify($err);
    }

    function critical($opt, $err = null) {
        syslog(LOG_CRIT, 'CRIT: ' . $opt);
        HLog::_doNotify($err);
    }

    function error($opt, $err = null) {
        syslog(LOG_ERR, 'ERR: ' . $opt);
        HLog::_doNotify($err);
    }

    function warning($opt, $err = null) {
        syslog(LOG_WARNING, 'WARN: ' . $opt);
    }

    function notice($opt, $err = null) {
        syslog(LOG_NOTICE, 'NOTICE: ' . $opt);
    }

    function sysError($errno, $errstr, $file, $line) {
        syslog(LOG_CRIT, 'PHP system error occured');
        HLog::_doNotify();
    }

    function _doNotify($err = null) {
        if (empty($err)) {
            $dbg = debug_backtrace();
        }
        else {
            $dbg = $err->getBacktrace();
        }
        $dbg['environment'] = $_SERVER;
        HNotifier::alert($dbg);
    }

    function _errorCallback($errno, $errstr, $errfile, $errline) {
        switch ($errno) {
        case E_NOTICE:
        case E_USER_NOTICE:
        case E_USER_WARNING:
            return;
        }
        if (error_reporting() != 0) {
            HLog::sysError($errno, $errstr, $errfile, $errline);
        }
    }
}
?>